package ex5;

import java.io.BufferedReader;
import java.io.InputStreamReader;

enum TokenClass {
    IDENT, DELIMITER, NUM, EOF
}

enum CharClass {
    DIGIT, LETTER, SEMI, EOF, OTHERS
}

public class TestTokenizer {
    StringBuilder stringBuffer;
    CharReader reader;
    char ch;

    public TestTokenizer(CharReader reader) {
        this.reader = reader;
        stringBuffer = new StringBuilder();
        ch = reader.nextChar();
    }

    CharClass getCharClass(char ch){
        if (Character.isDigit(ch))
            return CharClass.DIGIT;
        if (Character.isLetter(ch))
            return CharClass.LETTER;
        if (ch == ';')
            return CharClass.SEMI;
        if (ch == CharReader.CHAR_EOF)
            return CharClass.EOF;
        return CharClass.OTHERS;
    }

    String currentString(){
        return stringBuffer.toString();
    }

    TokenClass nextToken(){
        stringBuffer.setLength(0);
        int nextState = 1;
        while(ch==' ' || ch=='\n')  // 󔒂sǂݔ΂B
            ch = reader.nextChar();
        while(true){
            state:
            switch(nextState){
                case 1:
                    //̎_łłchɂ͎̃g[N̈ꕶڂĂB
                    stringBuffer.append(ch);
                    switch (getCharClass(ch)) {
                        case LETTER:
                            nextState = 2; break state;
                        case DIGIT:
                            nextState = 3; break state;
                        case SEMI:
                            nextState = 4; break state;
                        case EOF:
                            return TokenClass.EOF;
                        default:  // {G[ƂׂBł́GƓƂB
                            nextState = 4; break state;
                    }
                case 2:
                    ch = reader.nextChar();
                    if(getCharClass(ch)== CharClass.LETTER ||
                            getCharClass(ch)==CharClass.DIGIT){
                        stringBuffer.append(ch);
                        nextState = 2; break state;
                    } else
                        return TokenClass.IDENT;
                case 3:
                    ch = reader.nextChar();
                    if(getCharClass(ch) == CharClass.DIGIT){
                        stringBuffer.append(ch);
                        nextState = 3; break state;
                    } else return TokenClass.NUM;
                case 4:
                    ch = reader.nextChar();
                    return TokenClass.DELIMITER;
                default:
                    throw new RuntimeException("should not reach");
            }

        }

    }
    public static void main(String[] args) {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        TestTokenizer tokenizer = new TestTokenizer(new CharReader(br));
        TokenClass tc;
        while((tc= tokenizer.nextToken())!= TokenClass.EOF){
            //EOF(Ō̃g[Nj܂ŁAPg[NoďB
            System.out.print("tc = " + tc + " : ");
            System.out.println("tokenizer.currentString() = " + tokenizer.currentString());
        }
    }


}
